mscorlib 4.0.0.0 Contravariant To be added.

The and interfaces provide a generalized mechanism for push-based notification, also known as the observer design pattern. The interface represents the class that sends notifications (the provider); the interface represents the class that receives them (the observer). represents the class that provides the notification information.

An implementation arranges to receive notifications from a provider (an implementation) by passing an instance of itself to the provider's method. This method returns an object that can be used to unsubscribe the observer before the provider finishes sending notifications.

The interface defines the following three methods that the observer must implement:

The method, which is typically called by the provider to supply the observer with new data or state information.

The method, which is typically called by the provider to indicate that data is unavailable, inaccessible, or corrupted, or that the provider has experienced some other error condition.

The method, which is typically called by the provider to indicate that it has finished sending notifications to observers.

Provides a mechanism for receiving push-based notifications.

- Method
  4.0.0.0
  System.Void

  When the observer's implementation is called, the method can optionally call the method of the object that was returned to the observer when it called the method.

  Notifies the observer that the provider has finished sending push-based notifications.

- Method
  4.0.0.0
  System.Void ``

  Although is an object that is derived from , it does not necessarily represent an exception that is thrown by the provider. It can also represent a routine or expected error condition, such as data that is missing or unavailable. The method should be seen as informational, and the provider should not expect the observer to provide error handling.

  Notifies the observer that the provider has experienced an error condition.

  An object that provides additional information about the error.
- Method
  4.0.0.0
  System.Void `` To be added. To be added. To be added.